
package net.mcreator.shulkerarmor.enchantment;

import net.minecraft.world.item.enchantment.Enchantments;
import net.minecraft.world.item.enchantment.EnchantmentCategory;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.entity.EquipmentSlot;

import java.util.List;

public class ShulkerAspectEnchantment extends Enchantment {
	public ShulkerAspectEnchantment(EquipmentSlot... slots) {
		super(Enchantment.Rarity.RARE, EnchantmentCategory.WEAPON, slots);
	}

	@Override
	public int getMaxLevel() {
		return 2;
	}

	@Override
	protected boolean checkCompatibility(Enchantment ench) {
		return this != ench && !List.of(Enchantments.FLAMING_ARROWS, Enchantments.FIRE_ASPECT).contains(ench);
	}

	@Override
	public boolean isTreasureOnly() {
		return true;
	}
}
